	PROGRAM PROG101

C	BY A.K. COKER
C	A.K.C. TECHNOLOGY, 2010
C	WEST MIDLANDS, U.K



C	CALCULATION OF THE DEW POINT AND BUBBLE POINT OF GAS MIXTURE.
C	THIS PROGRAM WILL CALCULATE DEW POINT AND BUBBLE POINT BASED
C	ON THE SUPPLIED K-VALUES.
C	THE PROGRAM WILL COVER FEED STREAMS CONTAINING UP TO 15
C	COMPONENTS.
C
C	***************************************************************
C	FEED	= FEED CONDITION, (DEW) OR (BUBBLE) POINT
C	Ki 	= EQUILIBRIUM FLASH CONSTANT FOR EACH FEED STREAM
C	Mi 	= TOTAL MOLES OF COMPONENT i IN THE FEED STREAM
C	Ni	= MOLE FRACTION OF COMPONENT i IN THE FEED STREAM
C	T  	= TEMPERATURE, oF
C	P 	= PRESSURE, PSIA
C	J	= NUMBER OF DATA VALUES
C	***************************************************************

	CHARACTER*10 FEED
C 
	COMMON/DATA/BP,DP,J,K,N,T,P
	
	REAL K(20), M(20), N(20), BP(20), DP(20)

	OPEN(UNIT=3,FILE='DATA101.DAT',STATUS='OLD',ACTION='READ',
     *	ERR=18)
	
	
	OPEN (UNIT = 1, FILE='RES101.res')


C	READ EITHER THE DEW POINT OR BUBBLE POINT TEMPERATURE
C	READ THE TOTAL NUMBER OF COMPONENTS
C	READ THE MOLES OF EACH FEED COMPONENT
C	READ THE K-VALUE OF EACH COMPONENT
C
	READ (3, 10, ERR=19) FEED

 10	FORMAT (A6)

	READ (3, *, ERR=19) T

	READ (3, *, ERR = 19) P

	READ (3, *, ERR=19) J

	READ (3, *, ERR=19)(M(I),K(I),I=1,J)



	WRITE (1, 100)
	
 100	FORMAT (/,6X,'DEW AND BUBBLE POINTS CALCULATIONS AT '\)
 
 	WRITE (1, 101) T, P
 
 101    FORMAT (F6.1, 1X, 'DEG. F', 1X, 'AND', 1X, F6.1, 1X, 'PSIA')
     
  
	WRITE (*, 1000)
	
 1000	FORMAT (/,6X,'DEW AND BUBBLE POINTS CALCULATIONS AT '\)
 
 	WRITE (*, 1001) T, P
 	
 1001	FORMAT (F6.1, 1X, 'DEG. F', 1X, 'AND', 1X, F6.1, 1X, 'PSIA')	
 
 
	WRITE (1, 110) FEED
	
 110	FORMAT (/,6X, A6, 1X,'POINT CALCULATION', /1H , 76(1H*))
 

	WRITE (*, 1100) FEED
	
 1100	FORMAT (/,6X, A6, 1X,'POINT CALCULATION', /1H , 76(1H*))
 

	WRITE (1, 120) T
	
  120	FORMAT (/,6X,'TEMPERATURE oF:',F10.2)
 

	WRITE (*, 1200) T
	
 1200	FORMAT (/,6X,'TEMPERATURE oF:',F10.2)
 


	WRITE (1, 130) J
	
 130	FORMAT (/,6X,'NUMBER OF COMPONENTS IN THE FEED STREAM:',I2)
 
	WRITE (*, 1300) J
	
 1300	FORMAT (/,6X,'NUMBER OF COMPONENTS IN THE FEED STREAM:',I2)
 

	WRITE (1, 140)
	
 140  FORMAT (/,6X,'NUMBER OF COMPONENTS',6X,'FEED COMPOSITION (MOLE %)',
     *		6X,'K-VALUE',/1H ,76(1H-))


	WRITE (*, 1400)
	
 1400  FORMAT(/,6X,'NUMBER OF COMPONENTS',6X,'FEED COMPOSITION(MOLE %)',
     *		6X,'K-VALUE',/1H ,76(1H-))

	DO I = 1, J
	
	WRITE (1, 150) I,M(I),K(I)

 150	FORMAT (13X, I2, 24X, F8.4, 13X, F8.4)
 
	WRITE (*, 1500) I,M(I),K(I)

 1500	FORMAT (13X, I2, 24X, F8.4, 13X, F8.4)
  
 
	END DO

	GO TO 20
	
   18	WRITE (1, 160)
   
 160	FORMAT (6X,'DATA FILE DOES NOT EXIST')
 
        WRITE (*, 1600)
   
 1600	FORMAT (6X,'DATA FILE DOES NOT EXIST')
 

	GO TO 999

   19	WRITE (1, 170)
   
 170	FORMAT (6X,'ERROR MESSAGE IN THE DATA VALUE')
 
	GO TO 999

 20	SUM=0.0

	DO I = 1, J
	
	SUM=SUM+M(I)

	END DO

	WRITE (1, 180)
	
 180	FORMAT (1H ,76(1H-))

	WRITE (1, 190)SUM
	
	
 190	FORMAT (6X,'TOTAL COMPOSITION:', T40, F8.4)
 
 
	WRITE (*, 1800)
	
 1800	FORMAT (1H ,76(1H-))
 

	WRITE (*, 1900)SUM
	
	
 1900	FORMAT (6X,'TOTAL COMPOSITION:', T40, F8.4)
 
 
C
C	CALCULATE THE MOLE FRACTION OF COMPONENT IN THE FEED STREAM
C
	DO I = 1, J

	N(I)=M(I)/SUM

	END DO

C
C	CHECK WHETHER THE FEED IS AT BUBBLE POINT OR DEW POINT.
C
	IF (FEED .EQ. 'DEW' .OR. FEED .EQ. 'dew') THEN
	
	GO TO 30
	
	ELSEIF (FEED .EQ. 'BUBBLE' .OR. FEED .EQ. 'bubble') THEN
	
	CALL BUBBLE
	
	GO TO 999
	
	ENDIF

 30	CALL DEW

	GO TO 999

	CLOSE (3,STATUS='KEEP')
	
	CLOSE (1)
	
 999	STOP

	END
C
C	***************************************************************
C	THIS PROGRAM CALCULATES THE DEW POINT
C	***************************************************************

	SUBROUTINE DEW
	
	COMMON/DATA/BP,DP,J,K,N,T,P
	
	REAL N(20), K(20), DP(20) , BP(20)

	DPT = 0.0

	DO I = 1, J

	DP(I)=N(I)/K(I)

	DPT=DPT+N(I)/K(I)

	END DO

	WRITE (1, 200)

 200	FORMAT (/,6X,'NUMBER OF COMPONENTS',6X,'MOLE FRACTION',16X,
     *		'X=Y/K',/1H ,76(1H-))


	WRITE (*, 2000)

 2000	FORMAT (/,6X,'NUMBER OF COMPONENTS',6X,'MOLE FRACTION',16X,
     *		'X=Y/K',/1H ,76(1H-))



	DO I =1, J

	WRITE (1, 210)I, N(I), DP(I)

 210	FORMAT (12X, I2, 16X, F8.4, 20X, F8.4)
 
	WRITE (*, 2100)I, N(I), DP(I)

 2100	FORMAT (12X, I2, 16X, F8.4, 20X, F8.4)
 


	END DO

	WRITE (1, 220)DPT

 220	FORMAT(1H ,76(1H-),/,6X,'TOTAL DEW POINT:', T59, F8.4)

	WRITE (*, 2200)DPT

 2200	FORMAT(1H ,76(1H-),/,6X,'TOTAL DEW POINT:', T59, F8.4)



	IF (DPT .GE. 1.0) THEN

	GO TO 10

	ELSE

	WRITE (1, 230)T

 230	FORMAT(/,6X,'LOWER THE DEW-POINT TEMPERATURE OF:',
     *  T45, F9.2, 1X,'oF')


	WRITE (*, 2300)T

 2300	FORMAT(/,6X,'LOWER THE DEW-POINT TEMPERATURE OF:',
     *  T45, F9.2, 1X,'oF')


	ENDIF


	GO TO 20

 10	WRITE (1, 240)T

 240	FORMAT(/,6X,'RAISE THE DEW-POINT TEMPERATURE OF:',
     *  T45, F9.2,1X'oF')

	WRITE (*, 2400)T

 2400	FORMAT(/,6X,'RAISE THE DEW-POINT TEMPERATURE OF:',
     *  T45, F9.2,1X,'oF')



 20	RETURN
	END
C
C
C	*****************************************************************
C	THIS PROGRAM CALCULATES THE BUBBLE-POINT
C	*****************************************************************
C
	SUBROUTINE BUBBLE
	
	COMMON/DATA/BP,DP,J,K,N,T,P
	
	REAL N(20), K(20), DP(20), BP(20)

	BPT=0.0

	DO I = 1, J

	BP(I) =N(I)*K(I)

	BPT=BPT+N(I)*K(I)

	END DO

	WRITE (1, 250)

 250	FORMAT (/,6X, 'NUMBER OF COMPONENTS', 6X, 'MOLE FRACTION',16X,
     *		'Y=KX',/1H ,76(1H-))

	WRITE (*, 2500)

 2500	FORMAT (/,6X, 'NUMBER OF COMPONENTS', 6X, 'MOLE FRACTION',16X,
     *		'Y=KX',/1H ,76(1H-))


	DO I =1 ,J

	WRITE (1, 260) I, N(I), BP(I)

 260	FORMAT (12X, I2, 16X, F8.4, 20X, F8.4)

	WRITE (*, 2600) I, N(I), BP(I)

 2600	FORMAT (12X, I2, 16X, F8.4, 20X, F8.4)


	END DO

	WRITE (1, 270)BPT

 270	FORMAT(1H ,76(1H-),/,6X,'TOTAL BUBBLE POINT:', T59, F8.4)
 
	WRITE (*, 2700)BPT

 2700	FORMAT(1H ,76(1H-),/,6X,'TOTAL BUBBLE POINT:', T59, F8.4)
  

	IF (BPT .GE. 1.0) THEN

	GO TO 30

	ELSE

	WRITE (1, 280)T

 280	FORMAT(/,6X,'RAISE THE BUBBLE POINT TEMPERATURE OF:',
     *  T45,F9.2,' oF')

	WRITE (*, 2800)T

 2800	FORMAT(/,6X,'RAISE THE BUBBLE POINT TEMPERATURE OF:',
     *  T45,F9.2,' oF')


	ENDIF

	GO TO 35

   30	WRITE (1, 290)T

 290	FORMAT(/,6X,'LOWER THE BUBBLE POINT TEMPERATURE OF:',
     *  T45,F9.2,' oF')
 
	WRITE (*, 2900)T

 2900	FORMAT(/,6X,'LOWER THE BUBBLE POINT TEMPERATURE OF:',
     *  T45,F9.2,' oF')
  

  35	RETURN

	END
